<template>
    <div class="Sidebar" id="sidebar">

        <Grid class="Grid"
              v-bind:columns="gridColumns"
              v-bind:users="filteredUsers"
              v-bind:open-user-data="openUserData"
              v-on:select-user="selectUser"
              v-on:open-user="openUser"
        />

        <div class="EmptyList" v-if="!selectUsers().length">
            <p>Сделайте свой выбор!!!</p>
        </div>
        <Grid v-else
              class="Grid"
              v-bind:columns="gridColumns"
              v-bind:users="selectUsers()"
              v-bind:onlySelected="true"
              v-on:select-user="unselectUser"
        />

    </div>
</template>

<script>
    import Grid from './Grid';

    export default {
        name: "Sidebar",
        props: {
            usersData: Array,
            filterKey: String,
            openUserData: Object,
        },
        components: {Grid},
        data() {
            return {
                gridColumns: ['id','User'],
            }
        },
        methods: {
            unselectUser(id){
                this.$emit('unselect-user', id);
            },
            selectUser(id){
                this.$emit('select-user', id);
            },

            selectUsers: function () {
                let usersArr = this.filteredUsers;
                return usersArr.filter(user => user.selected === true);
            },
            openUser(login){
                this.$emit('open-user', login);
            },
        },
        computed: {
            filteredUsers: function () {
                const filterKey = this.filterKey && this.filterKey.toLowerCase();
                let usersArr = this.usersData;

                if (filterKey) {
                    usersArr = usersArr.filter((user) => {
                        const body = user.id + user.login;
                        return body.toLowerCase().indexOf(filterKey) > -1
                    })
                }

                return usersArr
            }
        }
    }


</script>

<style scoped>
    .Sidebar {
        display: flex;
        justify-content: space-around;
    }
    .Grid {
        width: 45%;
        min-width: 500px;
        background-color: bisque;
    }
    .EmptyList {
        width: 45%;
        height: 500px;
        display: flex;
        justify-content: center;
        align-items: center;
        min-width: 500px;
        font-weight: bold;
        font-size: xx-large;
    }

</style>